#!/usr/bin/perl

#
#		Binkleyforce history builder 1.0
#
#	   t-hist    binkleyforce.
#
#	    history   bforce.
#	 ,       
#	  history,       
#	 (0-, 1-  ..),    
#	  ()  ftn'   
#	  (2:5022/128 -  2:5022/128.*   ).
#
#	   ,    
#	 :
#
#	2:5022/128.8	                                 
#			
#	2:5020/52	                                  
#	2:5020/238	                                  
#	2:5020/4441	                                 
#			
#	2:5022/5	 
#
#	os_stat.pl /var/log/bforce/history 1 2:5022/128
#
#		Oleg Smirnov, 2:5022/128
#

$date = `date \"+%Y %m %d\"`;
@date = split (" ", $date);
@date[2]-=$ARGV[1];

$bfhist = $ARGV[0];

$first_aka = "^$ARGV[2]";

$first_aka =~ s/\:/\\\:/g;
$first_aka =~ s/\//\\\//g;
$first_aka =~ s/\./\\\./g;

$ut_begin	= `date -v@date[0]y -v@date[1]m -v@date[2]d -v0H -v0M -v0S +%s`;

$ut_day		= 60 * 60 * 24;

$ut_begin	=~ s/\n//g;
$ut_end		= $ut_begin + $ut_day;

$ckl=0;
foreach $x (`cat $bfhist`){
    $x =~ s/\n//g;
    @string = split ("\,", $x);
    if ( ( $string[2] >= $ut_begin ) && ( $string[2] <= $ut_end ) && ( $string[1] =~ /[0-9]/)){
	$exist=0;
	for ( $check=0; $check<$ckl; $check++ ){
	    if ($aka[$check] eq $string[1]){
		$exist=1;
		last;
	    }
	}
	if ( $exist == 0 ){
	    $aka[$ckl] = $string[1];
	    $ckl++;
	}
    }
}

sort_aka ();

$maxlen=14;

$number = $ckl - 1;

$otstup="";
for ($ckl_len=0;$ckl_len<$maxlen;$ckl_len++){
    $otstup="$otstup ";
}
print "\n      \n";
print "         Summary sessions history for 3 lines   \n";
print "      \n";

print "\n                      From 0:00:00 to 23:59:59, $date[2].$date[1].$date[0]\n\n";

print "$otstup 0   2   4   6   8  10  12  14  16  18  20  22  24\n";
print "$otstup ses  recv  sent\n";

$glb_sent=0;
$glb_recv=0;
$glb_flags_p=0;
$glb_flags_o=0;
$glb_flags_i=0;
$glb_time_in=0;
$glb_time_out=0;
$test_stat=0;

for ( $ckl=0; $ckl<=$number; $ckl++ ){
    $sess=0;
    $r_sent=0;
    $r_recv=0;
    $r_flags_p =0;
    $r_flags_o =0;
    $r_flags_i =0;
    $np=0;
    clear_stringgrp ();
    foreach $x (`cat $bfhist | grep \"$aka[$ckl]\"`){
	$x =~ s/\n//g;
	@string = split ("\,", $x);
	if ( ( $string[2] >= $ut_begin ) && ( $string[2] <= $ut_end ) && ( $string[1] =~ /[0-9]/)){
	    $r_node = $string[1];
	    $r_start = $string[2] - $ut_begin;
	    $r_len = $string[3];
	    if ( $string[4] =~ /P/ ){ $r_flags_p++; }
	    if ( $string[4] =~ /O/ ){ $r_flags_o++; $glb_time_out+=$r_len; }
	    if ( $string[4] =~ /I/ ){ $r_flags_i++; $glb_time_in+=$r_len; }
	    $r_sent += $string[6] + $string[7] + $string[8];
	    $r_recv += $string[9] + $string[10] + $string[11];
	    
	    $sess++;
	    if ( $np == 0 ){
		$l_r_node = length ( $r_node );
		if ( $l_r_node <= $maxlen ){
		    for ($ckll=$l_r_node;$ckll<=$maxlen;$ckll++){
		            $r_node = "$r_node ";
		    }
		}
	        @test_now = split (/\//, $r_node);
		if ( $test_stat == 0){
		    $test_stat=1;
		}else{
		    if ( $test_now[0] ne $test_old[0] ){
			print "$otstup \n";
		    }
		}
		@test_old = @test_now;
    
		printf ("%s", $r_node);
		$np=1;
	    }
	    set_pimp();
	}
    }

    SWITCH: {
	if ( $r_sent >= 1073741824 ){
	    $r_sent_b = int $r_sent / 1024 / 1024 / 1024;
	    $r_sent_b = sprintf ( "%sG", $r_sent_b);
	    last SWITCH;
	}
	if ( $r_sent >= 1048576 ){
	    $r_sent_b = int $r_sent / 1024 / 1024;
	    $r_sent_b = sprintf ( "%sM", $r_sent_b);
	    last SWITCH;
	}
	if ( $r_sent >= 1024 ){
	    $r_sent_b = int $r_sent / 1024;
	    $r_sent_b = sprintf ( "%sK", $r_sent_b);
	    last SWITCH;
	}
	if ( $r_sent == 0 ){
	    $r_sent_b = sprintf ( "0");
	    last SWITCH;
	}
	$r_sent_b = sprintf ( "%sb", $r_sent);
    }

    SWITCH: {
	if ( $r_recv >= 1073741824 ){
	    $r_recv_b = int $r_recv / 1024 / 1024 / 1024;
	    $r_recv_b = sprintf ( "%sG", $r_recv_b);
	    last SWITCH;
	}
	if ( $r_recv >= 1048576 ){
	    $r_recv_b = int $r_recv / 1024 / 1024;
	    $r_recv_b = sprintf ( "%sM", $r_recv_b);
	    last SWITCH;
	}
	if ( $r_recv >= 1024 ){
	    $r_recv_b = int $r_recv / 1024;
	    $r_recv_b = sprintf ( "%sK", $r_recv_b);
	    last SWITCH;
	}
	if ( $r_recv == 0 ){
	    $r_recv_b = sprintf ( "0");
	    last SWITCH;
	}
	$r_recv_b = sprintf ( "%sb", $r_recv);
    }

    print @stringgrp;
    printf ("%3s %5s %5s\n", $sess, $r_recv_b, $r_sent_b);

    $glb_sent+=$r_sent;
    $glb_recv+=$r_recv;
    $glb_flags_p+=$r_flags_p;
    $glb_flags_o+=$r_flags_o;
    $glb_flags_i+=$r_flags_i;

}

print "$otstup \n";
print "$otstup 0   2   4   6   8  10  12  14  16  18  20  22  24\n";

$glb_traf = $glb_sent + $glb_recv;
$glb_flags_sess = $glb_flags_o + $glb_flags_i;
$glb_time_total = $glb_time_out + $glb_time_in;

    SWITCH: {
	if ( $glb_sent >= 1073741824 ){
	    $glb_sent = int $glb_sent / 1024 / 1024 / 1024;
	    $glb_sent = sprintf ( "%sG", $glb_sent);
	    last SWITCH;
	}
	if ( $glb_sent >= 1048576 ){
	    $glb_sent = int $glb_sent / 1024 / 1024;
	    $glb_sent = sprintf ( "%sM", $glb_sent);
	    last SWITCH;
	}
	if ( $glb_sent >= 1024 ){
	    $glb_sent = int $glb_sent / 1024;
	    $glb_sent = sprintf ( "%sK", $glb_sent);
	    last SWITCH;
	}
	if ( $glb_sent == 0 ){
	    $glb_sent = sprintf ( "0");
	    last SWITCH;
	}
	$glb_sent = "$glb_sent\0b";
	$glb_sent = sprintf ( "%sb", $glb_sent);
    }

    SWITCH: {
	if ( $glb_recv >= 1073741824 ){
	    $glb_recv = int $glb_recv / 1024 / 1024 / 1024;
	    $glb_recv = sprintf ( "%sG", $glb_recv);
	    last SWITCH;
	}
	if ( $glb_recv >= 1048576 ){
	    $glb_recv = int $glb_recv / 1024 / 1024;
	    $glb_recv = sprintf ( "%sM", $glb_recv);
	    last SWITCH;
	}
	if ( $glb_recv >= 1024 ){
	    $glb_recv = int $glb_recv / 1024;
	    $glb_recv = sprintf ( "%sK", $glb_recv);
	    last SWITCH;
	}
	if ( $glb_recv == 0 ){
	    $glb_recv = sprintf ( "0");
	    last SWITCH;
	}
	$glb_recv = sprintf ( "%sb", $glb_recv);
    }

    SWITCH: {
	if ( $glb_traf >= 1073741824 ){
	    $glb_traf = int $glb_traf / 1024 / 1024 / 1024;
	    $glb_traf = sprintf ( "%sG", $glb_traf);
	    last SWITCH;
	}
	if ( $glb_traf >= 1048576 ){
	    $glb_traf = int $glb_traf / 1024 / 1024;
	    $glb_traf = sprintf ( "%sM", $glb_traf);
	    last SWITCH;
	}
	if ( $glb_traf >= 1024 ){
	    $glb_traf = int $glb_traf / 1024;
	    $glb_traf = sprintf ( "%sK", $glb_traf);
	    last SWITCH;
	}
	if ( $glb_traf == 0 ){
	    $glb_traf = sprintf ( "0");
	    last SWITCH;
	}
	$glb_traf = sprintf ( "%sb", $glb_traf);
    }

$glb_time_in_h = int ( $glb_time_in / 60 / 60);
$glb_time_in_m = int (($glb_time_in - $glb_time_in_h * 60 * 60) / 60);
$glb_time_in_s = int ($glb_time_in - $glb_time_in_h * 60 * 60 - $glb_time_in_m * 60);
if ( length $glb_time_in_h < 2 ){ $glb_time_in_h = "0$glb_time_in_h"; }
if ( length $glb_time_in_m < 2 ){ $glb_time_in_m = "0$glb_time_in_m"; }
if ( length $glb_time_in_s < 2 ){ $glb_time_in_s = "0$glb_time_in_s"; }
$glb_time_in   = "$glb_time_in_h:$glb_time_in_m:$glb_time_in_s";

$glb_time_out_h = int ($glb_time_out / 60 / 60);
$glb_time_out_m = int (($glb_time_out - $glb_time_out_h * 60 * 60) / 60);
$glb_time_out_s = int ($glb_time_out - $glb_time_out_h * 60 * 60 - $glb_time_out_m * 60);
if ( length $glb_time_out_h < 2 ){ $glb_time_out_h = "0$glb_time_out_h"; }
if ( length $glb_time_out_m < 2 ){ $glb_time_out_m = "0$glb_time_out_m"; }
if ( length $glb_time_out_s < 2 ){ $glb_time_out_s = "0$glb_time_out_s"; }
$glb_time_out   = "$glb_time_out_h:$glb_time_out_m:$glb_time_out_s";

$glb_time_total_h = int ($glb_time_total / 60 / 60);
$glb_time_total_m = int (($glb_time_total - $glb_time_total_h * 60 * 60) / 60);
$glb_time_total_s = int ($glb_time_total - $glb_time_total_h * 60 * 60 - $glb_time_total_m * 60);
if ( length $glb_time_total_h < 2 ){ $glb_time_total_h = "0$glb_time_total_h"; }
if ( length $glb_time_total_m < 2 ){ $glb_time_total_m = "0$glb_time_total_m"; }
if ( length $glb_time_total_s < 2 ){ $glb_time_total_s = "0$glb_time_total_s"; }
$glb_time_total   = "$glb_time_total_h:$glb_time_total_m:$glb_time_total_s";

printf ("\n\n");
printf (" Total Received : %7s  Total Ses In  : %5s  Time In      :  %8s \n", $glb_recv, $glb_flags_i, $glb_time_in );
printf (" Total Sent     : %7s  Total Ses Out : %5s  Time Out     :  %8s \n", $glb_sent, $glb_flags_o, $glb_time_out );
printf (" Total Traffic  : %7s  Total Sessions: %5s  Time Online  :  %8s \n", $glb_traf, $glb_flags_sess, $glb_time_total );
printf ("\n");

$pv = `perl -v | head -n 2 | tail -n 1`;
$pv =~ s/\n//g;
@pv = split ("\,", $pv);

print "\n \n";
print "  Binkleyforce history builder 1.0 (c) Oleg Smirnov, 2:5022/128.\n";
print "  Using Perl$pv[1]\n";
print "  (skin borrowed from T-Hist)\n";

exit ();

sub sort_aka () {
    @des = sort @aka;
    for ( $ckl_srt1=0; $ckl_srt1<$#des; $ckl_srt1++){
	for ( $ckl_srt2=$ckl_srt1+1; $ckl_srt2<=$#des; $ckl_srt2++){
	    @x1 = split (/\:/, @des[$ckl_srt1]);
	    @x2 = split (/\//, $x1[1]);
	    @x3 = split (/\./, $x2[1]);
	    $xa[0] = $x1[0];
	    $xa[1] = $x2[0];
	    $xa[2] = $x3[0];
	    $xa[3] = $x3[1];
	    @x1 = split (/\:/, @des[$ckl_srt2]);
	    @x2 = split (/\//, $x1[1]);
	    @x3 = split (/\./, $x2[1]);
	    $xb[0] = $x1[0];
	    $xb[1] = $x2[0];
	    $xb[2] = $x3[0];
	    $xb[3] = $x3[1];
	    if ( $xb[0] > $xa[0] ){
		$temp_aka = @des[$ckl_srt1];
		@des[$ckl_srt1] = @des[$ckl_srt2];
		@des[$ckl_srt2] = $temp_aka;
	    }else{
		if ( $xb[0] == $xa[0] && $xb[1] < $xa[1] ){
		    $temp_aka = @des[$ckl_srt1];
		    @des[$ckl_srt1] = @des[$ckl_srt2];
		    @des[$ckl_srt2] = $temp_aka;
		}else{
		    if ( $xb[1] == $xa[1] && $xb[2] < $xa[2] ){
			$temp_aka = @des[$ckl_srt1];
			@des[$ckl_srt1] = @des[$ckl_srt2];
			@des[$ckl_srt2] = $temp_aka;
		    }else{
			if ( $xb[2] == $xa[2] && $xb[3] < $xa[3] ){
			    $temp_aka = @des[$ckl_srt1];
			    @des[$ckl_srt1] = @des[$ckl_srt2];
			    @des[$ckl_srt2] = $temp_aka;
			}
		    }
		}
	    }
	}
    }
    $start_num=0;
    for ( $ckl_srt=0; $ckl_srt<=$#des; $ckl_srt++){
	if ( $des[$ckl_srt] =~ /$first_aka/ ){
	    $aka[$start_num] = $des[$ckl_srt];
	    $start_num++;
	}
    }
    for ( $ckl_srt=0; $ckl_srt<=$#des; $ckl_srt++){
	if ( $des[$ckl_srt] =~ /$first_aka/ ){}else{
	    $aka[$start_num] = $des[$ckl_srt];
	    $start_num++;
	}
    }
}

sub set_pimp (){
    $r_start = int ( $r_start / 60 / 15 );
    $r_len = int ( $r_len / 60 / 15 );
    if ( ( int ( $r_start / 2 ) / 2 == 0 ) && ( $r_len > 1 ) ){
	$stringgrp[int($r_start/2)]="";
	draw_line ();
    }
    if ( ( int ( $r_start / 2 ) / 2 == 0 ) && ( $r_len < 2 ) ){
	$stringgrp[int($r_start/2)]="";
    }
    if ( ( int ( $r_start / 2 ) / 2 != 0 ) ){
	$stringgrp[int($r_start/2)]="";
	if ( $r_len > 1 ){ draw_line (); }
    }
    if ( $stringgrp[0] ne "" ){
	$stringgrp[0]="";
    }
    if ( $stringgrp[48] ne "" ){
	$stringgrp[48]="";
    }
}

sub clear_stringgrp (){
    for ($cklstr=0; $cklstr<=48; $cklstr++){
	if ( int($cklstr/4)*4 == $cklstr ){
	    $stringgrp[$cklstr] = "";
	}else{
	    $stringgrp[$cklstr] = " ";
	}
    }
}

sub draw_line (){
    for ( $cklrl=0; $cklrl<=$r_len; $cklrl+=2){
	if ( (int($r_start/2)+$cklrl/2) > 48 ){ last; }
	if ( ( $r_len - $cklrl ) == 2 ){
	    $stringgrp[int($r_start/2)+$cklrl/2]="";
	    last;
	}
	if ( ( $r_len - $cklrl ) == 1 ){
	    $stringgrp[int($r_start/2)+$cklrl/2]="";
	    last;
	}
	$stringgrp[int($r_start/2)+$cklrl/2]="";
    }

}
